
//Crystal=8M
//MCU=STC10F04XE
//P0.0-P0.6 LED 
//Trig  = P1^0
//Echo  = P3^2
#include <reg52.h>      
#define uchar unsigned char  
#define uint  unsigned int
#define ulong unsigned long
//***********************************************
sfr  CLK_DIV = 0x97; //freq set
                   
sfr   P0M1   = 0X93;
sfr   P0M0   = 0X94;
sfr   P1M1   = 0X91;
sfr   P1M0   = 0X92;
sfr	P2M1   = 0X95;
sfr	P2M0   = 0X96;
//***********************************************
sbit Trig  = P1^0; //PULSE GENERATE PIN
sbit Echo  = P3^2; //RECIVING BACK PULSE PIN
sbit test  = P1^1; //TEST PIN

uchar code SEG7[10]={0xC0,0xF9,0xA4,0xB0,0x99,0x92,0x82,0xF8,0x80,0x90}; //LED 0-9
uint distance[4];  //BUFFER
uchar ge,shi,bai,temp,flag,outcomeH,outcomeL,i;  //OWN REG
bit succeed_flag;  //GET OK
 
void conversion(uint temp_data);
void delay_20us();
//void pai_xu();

void main(void)   
{  uint distance_data,a,b;
   uchar CONT_1;   
   CLK_DIV=0X03; //  
     P0M1 = 0;   
     P1M1 = 0;
     P2M1 = 0;
     P0M0 = 0XFF;
     P1M0 = 0XFF;
     P2M0 = 0XFF;
   i=0;
   flag=0;
	test =0;
	Trig=0;      
	TMOD=0x11;     //TIMER
	TR0=1;	      
   IT0=0;           //INT
	ET0=1;        
 //ET1=1;       
	EX0=0;         
	EA=1;        
  
	
while(1)          
	{
  EA=0;
	     Trig=1;
        delay_20us();
        Trig=0;         //CREAT 20us PULSE AT TRIGER
        while(Echo==0); //WAIT Echo 
	     succeed_flag=0; //CLEAR 
	     EX0=1;        
	 	  TH1=0;         
        TL1=0;           
	     TF1=0;         
        TR1=1;        
   EA=1;

      while(TH1 < 30);//WAIT RESULT 65.535MS
		  TR1=0;         
        EX0=0;         

    if(succeed_flag==1)
	     { 	
		   distance_data=outcomeH;                //HIGH 8 BIT OF RESULT
           distance_data<<=8;               
		     distance_data=distance_data|outcomeL;//COMBINED WITH LOW 8 BIT OF RESULT
            distance_data*=12;              
           distance_data/=58;                
         }                                      // Y =X *344/2
			                                       // X= 2*Y /344 ==X =0.0058*Y  ==CM=ms/58 
    if(succeed_flag==0)
		   {
            distance_data=0;                 
		   	test = !test;                      
           }

     ///       distance[i]=distance_data;  
     ///        i++;
  	  ///	 if(i==3)
	  ///	     {
	  ///	       distance_data=(distance[0]+distance[1]+distance[2]+distance[3])/4;
     ///        pai_xu();
     ///        distance_data=distance[1];

      
	   a=distance_data;
       if(b==a) CONT_1=0;
       if(b!=a) CONT_1++;
       if(CONT_1>=3)
		   { CONT_1=0;
			  b=a;
			  conversion(b);
			}       
	  ///		 i=0;
 	  ///		}	     
	 }
}
//***************************************************************
 
INTO_()  interrupt 0    
 {    
     outcomeH =TH1;     
     outcomeL =TL1;   
     succeed_flag=1;    
     EX0=0;           
  }
//****************************************************************
 
timer0() interrupt 1   
   {
 	 TH0=0xfd;  
	 TL0=0x77;	 	
	 switch(flag)   
      {case 0x00:P0=ge; P2=0xfd;flag++;break;
	    case 0x01:P0=shi;P2=0xfe;flag++;break;
	    case 0x02:P0=bai;P2=0xfb;flag=0;break;
      }
   }
//*****************************************************************
/*
 
    {
TH1=0;
TL1=0;
     }
*/
//******************************************************************
//ʾת
void conversion(uint temp_data)  
 {  
    uchar ge_data,shi_data,bai_data ;
    bai_data=temp_data/100 ;
    temp_data=temp_data%100;   
    shi_data=temp_data/10 ;
    temp_data=temp_data%10;    
    ge_data=temp_data;

    bai_data=SEG7[bai_data];
    shi_data=SEG7[shi_data];
    ge_data =SEG7[ge_data];

    EA=0;
    bai = bai_data;
    shi = shi_data;
    ge  = ge_data ; 
	 EA=1;
 }
//******************************************************************
void delay_20us()
 {  uchar bt ;
    for(bt=0;bt<100;bt++);
 }
/*
void pai_xu()
  {  uint t;
  if (distance[0]>distance[1])
    {t=distance[0];distance[0]=distance[1];distance[1]=t;}  
  if(distance[0]>distance[2])
    {t=distance[2];distance[2]=distance[0];distance[0]=t;}  
  if(distance[1]>distance[2])
    {t=distance[1];distance[1]=distance[2];distance[2]=t;}  
    }
*/



 (1) Use I/O trigger, get an pulse signal which is at least 10us long; 

   (2) The ultra sonic module will automatically send eight 40khz square waves, automatically detects whether there is a reflect signal;

   (3) When there is an reflect signal back, the I/O will output a  high level, the duration of the high-level signal is the time from untral sonic launch to return. As a result,  the Measured distance = (T(Time of High-Level output ) * (340M / S)) / 2; 




















